# coding: utf-8

"""
    Gate API v4

    Welcome to Gate.io API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.  # noqa: E501

    Contact: support@mail.gate.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class CollateralAlign(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {'order_id': 'int', 'collateral_currency': 'str', 'collateral_amount': 'str', 'type': 'str'}

    attribute_map = {
        'order_id': 'order_id',
        'collateral_currency': 'collateral_currency',
        'collateral_amount': 'collateral_amount',
        'type': 'type',
    }

    def __init__(
        self, order_id=None, collateral_currency=None, collateral_amount=None, type=None, local_vars_configuration=None
    ):  # noqa: E501
        # type: (int, str, str, str, Configuration) -> None
        """CollateralAlign - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._order_id = None
        self._collateral_currency = None
        self._collateral_amount = None
        self._type = None
        self.discriminator = None

        self.order_id = order_id
        self.collateral_currency = collateral_currency
        self.collateral_amount = collateral_amount
        self.type = type

    @property
    def order_id(self):
        """Gets the order_id of this CollateralAlign.  # noqa: E501

        Order ID  # noqa: E501

        :return: The order_id of this CollateralAlign.  # noqa: E501
        :rtype: int
        """
        return self._order_id

    @order_id.setter
    def order_id(self, order_id):
        """Sets the order_id of this CollateralAlign.

        Order ID  # noqa: E501

        :param order_id: The order_id of this CollateralAlign.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and order_id is None:  # noqa: E501
            raise ValueError("Invalid value for `order_id`, must not be `None`")  # noqa: E501

        self._order_id = order_id

    @property
    def collateral_currency(self):
        """Gets the collateral_currency of this CollateralAlign.  # noqa: E501

        Collateral  # noqa: E501

        :return: The collateral_currency of this CollateralAlign.  # noqa: E501
        :rtype: str
        """
        return self._collateral_currency

    @collateral_currency.setter
    def collateral_currency(self, collateral_currency):
        """Sets the collateral_currency of this CollateralAlign.

        Collateral  # noqa: E501

        :param collateral_currency: The collateral_currency of this CollateralAlign.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and collateral_currency is None:  # noqa: E501
            raise ValueError("Invalid value for `collateral_currency`, must not be `None`")  # noqa: E501

        self._collateral_currency = collateral_currency

    @property
    def collateral_amount(self):
        """Gets the collateral_amount of this CollateralAlign.  # noqa: E501

        Collateral amount  # noqa: E501

        :return: The collateral_amount of this CollateralAlign.  # noqa: E501
        :rtype: str
        """
        return self._collateral_amount

    @collateral_amount.setter
    def collateral_amount(self, collateral_amount):
        """Sets the collateral_amount of this CollateralAlign.

        Collateral amount  # noqa: E501

        :param collateral_amount: The collateral_amount of this CollateralAlign.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and collateral_amount is None:  # noqa: E501
            raise ValueError("Invalid value for `collateral_amount`, must not be `None`")  # noqa: E501

        self._collateral_amount = collateral_amount

    @property
    def type(self):
        """Gets the type of this CollateralAlign.  # noqa: E501

        Operation types: append - for adding collateral, redeem - for withdrawing collateral  # noqa: E501

        :return: The type of this CollateralAlign.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CollateralAlign.

        Operation types: append - for adding collateral, redeem - for withdrawing collateral  # noqa: E501

        :param type: The type of this CollateralAlign.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CollateralAlign):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CollateralAlign):
            return True

        return self.to_dict() != other.to_dict()
