# coding: utf-8

"""
    Gate API v4

    Welcome to Gate.io API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.  # noqa: E501

    Contact: support@mail.gate.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class TotalBalance(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {'total': 'AccountBalance', 'details': 'dict(str, AccountBalance)'}

    attribute_map = {'total': 'total', 'details': 'details'}

    def __init__(self, total=None, details=None, local_vars_configuration=None):  # noqa: E501
        # type: (AccountBalance, dict(str, AccountBalance), Configuration) -> None
        """TotalBalance - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._total = None
        self._details = None
        self.discriminator = None

        if total is not None:
            self.total = total
        if details is not None:
            self.details = details

    @property
    def total(self):
        """Gets the total of this TotalBalance.  # noqa: E501


        :return: The total of this TotalBalance.  # noqa: E501
        :rtype: AccountBalance
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this TotalBalance.


        :param total: The total of this TotalBalance.  # noqa: E501
        :type: AccountBalance
        """

        self._total = total

    @property
    def details(self):
        """Gets the details of this TotalBalance.  # noqa: E501

        Total balances in different accounts  - cross_margin: cross margin account - spot: spot account - finance: finance account - margin: margin account - quant: quant account - futures: futures account - delivery: delivery account - warrant: warrant account - cbbc: cbbc account  # noqa: E501

        :return: The details of this TotalBalance.  # noqa: E501
        :rtype: dict(str, AccountBalance)
        """
        return self._details

    @details.setter
    def details(self, details):
        """Sets the details of this TotalBalance.

        Total balances in different accounts  - cross_margin: cross margin account - spot: spot account - finance: finance account - margin: margin account - quant: quant account - futures: futures account - delivery: delivery account - warrant: warrant account - cbbc: cbbc account  # noqa: E501

        :param details: The details of this TotalBalance.  # noqa: E501
        :type: dict(str, AccountBalance)
        """

        self._details = details

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TotalBalance):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TotalBalance):
            return True

        return self.to_dict() != other.to_dict()
